# Multiboot Web2IF by gutemine
from twisted.internet import reactor
from twisted.web2 import server, channel, static, resource, stream, http_headers, responsecode, http

import os
__version__ = "1.0"
class WIMultiboot(resource.Resource):
    
    title = "Multiboot Web2Interface by gutemine"
    mbdir = "/media/mb"
    mbinfo = ".mbinfo"
    mbconfig = "/media/mb/.mbconfig"
    mbmaxpartc = "/media/mb/.mbmaxpartc"
    mbmaxpartu = "/media/mb/.mbmaxpartu"
    mbmaxpartd = "/media/mb/.mbmaxpartd"
    
    def render(self, req):
        """ rendering server response """
        command = req.args.get("cmd",None)

        if os.path.exists(self.mbconfig) == False:
            html  = "<html><head><title>%s</title></head><body>" %self.title
            html += "Multiboot is not installed"
            html += "</body></html>"
            return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
        else:
           fp = open(self.mbconfig,"r")
           type =fp.readline()
           fp.close()
           if type[0] is not "c":
              html  = "<html><head><title>%s</title></head><body>" %self.title
              html += "Multiboot Web2IF is only supported for CF card only installation"
              html += "</body></html>"
              return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)

        if os.path.exists(self.mbmaxpartc) == True:
           fp = open(self.mbmaxpartc,"r")
           line =fp.readline()
           fp.close()
           endc = int(line)
        if os.path.exists(self.mbmaxpartd) == True:
           fp = open(self.mbmaxpartd,"r")
           line =fp.readline()
           fp.close()
           endd = int(line)
        if os.path.exists(self.mbmaxpartu) == True:
           fp = open(self.mbmaxpartu,"r")
           line =fp.readline()
           fp.close()
           endu = int(line)
        end = endc + endd + endu + 1
        html  = "<html><head><title>%s</title></head><body>" %self.title
        html += "<form method=\"GET\">"
        html += "<input type=\"hidden\" name=\"cmd\" value=\"boot\">"
        html += "<select name=\"image\">"
        html += "<option value=\"0\" selected>boot Flash: 0</option>"
        for x in range(1,end):
           if os.path.exists("%s%i/%s%i" % (self.mbdir,x,self.mbinfo,x)) == True:
              fp = open("%s%i/%s%i" % (self.mbdir,x,self.mbinfo,x) ,"r")
              name =fp.readline()
              fp.close()
              html += "<option value=\"%i\">boot %s</option>" % (x,name)
           else:
              if os.path.exists("/%s%i" % (self.mbinfo,x)) == True:
                 fp = open("/%s%i" % (self.mbinfo,x) ,"r")
                 name =fp.readline()
                 fp.close()
                 html += "<option value=\"%i\">boot %s</option>" % (x,name)
        html += "<input type=\"submit\" value=\"Send boot Command\">"
        html += "<input type=\"reset\" value=\"Reset boot Command\">"
        html += "</select>"
        html += "</form>"
        html += "<form method=\"GET\">"
        html += "<input type=\"hidden\" name=\"cmd\" value=\"info\">"
        html += "<input type=\"submit\" value=\"Show Multiboot Info\">"
        html += "</select>"
        html += "</form>"
        html += "<form method=\"GET\">"
        html += "<input type=\"hidden\" name=\"cmd\" value=\"reboot\">"
        html += "<input type=\"submit\" value=\"Reboot Dreambox\">"
        html += "</select>"
        html += "</form>"
        html += "</body>"
        html += "</html>"

        if command is None:
            return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
        
        elif command[0] == "info":
            html  = "<html><head><title>%s</title></head><body>" %self.title
            html += "<hr>"
            html += "Multiboot Web2IF Version %s - Showing available Partitions" % __version__
            html += "<hr>"
            booted = "Flash"
            for x in range(1,end):
              if os.path.exists("%s%i/%s%i" % (self.mbdir,x,self.mbinfo,x)) == True:
                 fp = open("%s%i/%s%i" % (self.mbdir,x,self.mbinfo,x) ,"r")
                 name =fp.readline()
                 fp.close()
                 html += "%s" % name
                 html += "<br>"
              else:
                 if os.path.exists("/%s%i" % (self.mbinfo,x)) == True:
                    fp = open("/%s%i" % (self.mbinfo,x) ,"r")
                    name =fp.readline()
                    fp.close()
                    booted = name
                    html += "%s" % name
                    html += "<br>"
                 else:
                    html += "Partition:  %i EMPTY\n" % x
                    html += "<br>"
            html += "<hr>"
            html += "You are booted from %s" % booted
            html += "<hr>"
            html += "autorun.bat on CF card for next reboot"
            html += "<hr>"
            if os.path.exists("/%s/autorun.bat" % self.mbdir) == True:
               fp = open("/%s/autorun.bat" % (self.mbdir) ,"r")
               line =fp.readline()
               html += "%s" % line
               html += "<br>"
               line =fp.readline()
               html += "%s" % line
               html += "<br>"
               fp.close()
            else:
               html += "no autorun.bat found" 
            html += "<hr>"
            html += "</body></html>"
            return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)

        elif command[0] == "boot":
            image = int(req.args.get("image","0")[0])
            
            if image is not 0:
               if os.path.exists("%s%i/%s%i" % (self.mbdir,image,self.mbinfo,image)) == True:
                  os.system("cp %s/autorun.bat%i %s/autorun.bat" % (self.mbdir,image,self.mbdir))
                  os.system("cp %s/bootlogo.mvi%i %s/bootlogo.mvi" % (self.mbdir,image,self.mbdir))
                  fp = open("%s%i/%s%i" % (self.mbdir,image,self.mbinfo,image) ,"r")
               else:
                  if os.path.exists("/%s%i" % (self.mbinfo,image)) == True:
                     os.system("cp %s/autorun.bat%i %s/autorun.bat" % (self.mbdir,image,self.mbdir))
                     os.system("cp %s/bootlogo.mvi%i %s/bootlogo.mvi" % (self.mbdir,image,self.mbdir))
                     fp = open("/%s%i" % (self.mbinfo,image) ,"r")
                  else:
                     html  = "<html><head><title>%s</title></head><body>" %self.title
                     html += "<hr>"
                     html += "Sorry, partition is empty"
                     html += "<hr>"
                     html += "</body></html>"
                     return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
 
               name =fp.readline()
               fp.close()
            else:
               os.system("cp %s/autorun.bat0 %s/autorun.bat" % (self.mbdir,self.mbdir))
               os.system("cp %s/bootlogo.mvi0 %s/bootlogo.mvi" % (self.mbdir,self.mbdir))

               name ="Flash"

            html  = "<html><head><title>%s</title></head><body>" %self.title
            html += "<hr>"
            html += "Changing next boot to %s" % name
            html += "<hr>"
            html += "</body></html>"
            return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)

        elif command[0] == "reboot":
            image = int(req.args.get("image","0")[0])
            os.system("reboot")
            html  = "<html><head><title>%s</title></head><body>" %self.title
            html += "<hr>"
            html += "rebooting Dreambox now !"
            html += "<hr>"
            html += "</body></html>"
            return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)

        else:
            html  = "<html><head><title>%s</title></head><body>" %self.title
            html += "<hr>"
            html += "unknown Multiboot command %s"%command
            html += "<hr>"
            html += "</body></html>"
            return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
                
    def control(self,type=0):
        cmdstr = "%s %s" %(self.path2control,type)
        return os.system(cmdstr)


